
_Init_MCP23008:

;MCP2003_Example.c,16 :: 		void Init_MCP23008(){
;MCP2003_Example.c,17 :: 		Delay_ms(10);
	MOVLW      26
	MOVWF      R12+0
	MOVLW      248
	MOVWF      R13+0
L_Init_MCP230080:
	DECFSZ     R13+0, 1
	GOTO       L_Init_MCP230080
	DECFSZ     R12+0, 1
	GOTO       L_Init_MCP230080
	NOP
;MCP2003_Example.c,18 :: 		Soft_I2C_Start(); // Issue start signal
	CALL       _Soft_I2C_Start+0
;MCP2003_Example.c,19 :: 		Soft_I2C_Write(0x40); // Address + Write bit
	MOVLW      64
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,20 :: 		Soft_I2C_Write(0x00); // Select IODIR register
	CLRF       FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,21 :: 		Soft_I2C_Write(0x80); // GP0-GP6 O/P, GP7 I/P
	MOVLW      128
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,22 :: 		Soft_I2C_Write(0x00); // IPOL
	CLRF       FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,23 :: 		Soft_I2C_Write(0x80); // GP7 Interrupt-on-change
	MOVLW      128
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,24 :: 		Soft_I2C_Write(0x80); // GP7 Def value 1
	MOVLW      128
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,25 :: 		Soft_I2C_Write(0x80); // Interrupts on GP7 compares to DEFVAL
	MOVLW      128
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,26 :: 		Soft_I2C_Write(0x22); // Disable further sequential write operation
	MOVLW      34
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,27 :: 		Soft_I2C_Stop();
	CALL       _Soft_I2C_Stop+0
;MCP2003_Example.c,30 :: 		Soft_I2C_Start(); // Issue start signal
	CALL       _Soft_I2C_Start+0
;MCP2003_Example.c,31 :: 		Soft_I2C_Write(0x40); // Address + Write bit
	MOVLW      64
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,32 :: 		Soft_I2C_Write(0x06); // Select IODIR register
	MOVLW      6
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,33 :: 		Soft_I2C_Write(0x80); // GP7 pull-up
	MOVLW      128
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,34 :: 		Soft_I2C_Stop();
	CALL       _Soft_I2C_Stop+0
;MCP2003_Example.c,36 :: 		}
	RETURN
; end of _Init_MCP23008

_mask:

;MCP2003_Example.c,38 :: 		unsigned short mask(unsigned short temp) {
;MCP2003_Example.c,39 :: 		switch (temp) {
	GOTO       L_mask1
;MCP2003_Example.c,40 :: 		case 0 : return 0x3F;
L_mask3:
	MOVLW      63
	MOVWF      R0+0
	RETURN
;MCP2003_Example.c,41 :: 		case 1 : return 0x06;
L_mask4:
	MOVLW      6
	MOVWF      R0+0
	RETURN
;MCP2003_Example.c,42 :: 		case 2 : return 0x5B;
L_mask5:
	MOVLW      91
	MOVWF      R0+0
	RETURN
;MCP2003_Example.c,43 :: 		case 3 : return 0x4F;
L_mask6:
	MOVLW      79
	MOVWF      R0+0
	RETURN
;MCP2003_Example.c,44 :: 		case 4 : return 0x66;
L_mask7:
	MOVLW      102
	MOVWF      R0+0
	RETURN
;MCP2003_Example.c,45 :: 		case 5 : return 0x6D;
L_mask8:
	MOVLW      109
	MOVWF      R0+0
	RETURN
;MCP2003_Example.c,46 :: 		case 6 : return 0x7D;
L_mask9:
	MOVLW      125
	MOVWF      R0+0
	RETURN
;MCP2003_Example.c,47 :: 		case 7 : return 0x07;
L_mask10:
	MOVLW      7
	MOVWF      R0+0
	RETURN
;MCP2003_Example.c,48 :: 		case 8 : return 0x7F;
L_mask11:
	MOVLW      127
	MOVWF      R0+0
	RETURN
;MCP2003_Example.c,49 :: 		case 9 : return 0x6F;
L_mask12:
	MOVLW      111
	MOVWF      R0+0
	RETURN
;MCP2003_Example.c,50 :: 		} //case end
L_mask1:
	MOVF       FARG_mask_temp+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_mask3
	MOVF       FARG_mask_temp+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_mask4
	MOVF       FARG_mask_temp+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_mask5
	MOVF       FARG_mask_temp+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_mask6
	MOVF       FARG_mask_temp+0, 0
	XORLW      4
	BTFSC      STATUS+0, 2
	GOTO       L_mask7
	MOVF       FARG_mask_temp+0, 0
	XORLW      5
	BTFSC      STATUS+0, 2
	GOTO       L_mask8
	MOVF       FARG_mask_temp+0, 0
	XORLW      6
	BTFSC      STATUS+0, 2
	GOTO       L_mask9
	MOVF       FARG_mask_temp+0, 0
	XORLW      7
	BTFSC      STATUS+0, 2
	GOTO       L_mask10
	MOVF       FARG_mask_temp+0, 0
	XORLW      8
	BTFSC      STATUS+0, 2
	GOTO       L_mask11
	MOVF       FARG_mask_temp+0, 0
	XORLW      9
	BTFSC      STATUS+0, 2
	GOTO       L_mask12
;MCP2003_Example.c,51 :: 		}
	RETURN
; end of _mask

_main:

;MCP2003_Example.c,54 :: 		void main() {
;MCP2003_Example.c,55 :: 		CMCON0 = 7;  // Disable Comparators
	MOVLW      7
	MOVWF      CMCON0+0
;MCP2003_Example.c,56 :: 		TRISIO = 0b00001100;       // All Outputs, except GP2 and GP3
	MOVLW      12
	MOVWF      TRISIO+0
;MCP2003_Example.c,57 :: 		ANSEL  = 0b00000000;       // All pins digital I/O
	CLRF       ANSEL+0
;MCP2003_Example.c,59 :: 		Soft_I2C_Init();
	CALL       _Soft_I2C_Init+0
;MCP2003_Example.c,60 :: 		Init_MCP23008();
	CALL       _Init_MCP23008+0
;MCP2003_Example.c,62 :: 		do {
L_main13:
;MCP2003_Example.c,63 :: 		while (IntPin == 0)
L_main16:
	BTFSC      GP2_bit+0, 2
	GOTO       L_main17
;MCP2003_Example.c,64 :: 		Delay_us(1);
	NOP
	NOP
	GOTO       L_main16
L_main17:
;MCP2003_Example.c,66 :: 		Soft_I2C_Start(); // Issue start signal
	CALL       _Soft_I2C_Start+0
;MCP2003_Example.c,67 :: 		Soft_I2C_Write(0x40); // Address + Write bit
	MOVLW      64
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,68 :: 		Soft_I2C_Write(0x08);   // Address of INTCAP register
	MOVLW      8
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,70 :: 		Soft_I2C_Start(); // Issue start signal
	CALL       _Soft_I2C_Start+0
;MCP2003_Example.c,71 :: 		Soft_I2C_Write(0x40+1); // Address + Read bit
	MOVLW      65
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,72 :: 		Delay_ms(300);
	MOVLW      4
	MOVWF      R11+0
	MOVLW      12
	MOVWF      R12+0
	MOVLW      51
	MOVWF      R13+0
L_main18:
	DECFSZ     R13+0, 1
	GOTO       L_main18
	DECFSZ     R12+0, 1
	GOTO       L_main18
	DECFSZ     R11+0, 1
	GOTO       L_main18
	NOP
	NOP
;MCP2003_Example.c,73 :: 		k = Soft_I2C_Read(0); // Read byte and don't acknowlegde
	CLRF       FARG_Soft_I2C_Read_ack+0
	CLRF       FARG_Soft_I2C_Read_ack+1
	CALL       _Soft_I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      _k+0
;MCP2003_Example.c,74 :: 		Soft_I2C_Stop();
	CALL       _Soft_I2C_Stop+0
;MCP2003_Example.c,75 :: 		disp = mask(num);
	MOVF       _num+0, 0
	MOVWF      FARG_mask_temp+0
	CALL       _mask+0
	MOVF       R0+0, 0
	MOVWF      _disp+0
;MCP2003_Example.c,76 :: 		Soft_I2C_Start(); // Issue start signal
	CALL       _Soft_I2C_Start+0
;MCP2003_Example.c,77 :: 		Soft_I2C_Write(0x40); // Address + Write bit
	MOVLW      64
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,78 :: 		Soft_I2C_Write(0x09); // Select GPIO register
	MOVLW      9
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,79 :: 		Soft_I2C_Write(disp); // Send Num
	MOVF       _disp+0, 0
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;MCP2003_Example.c,80 :: 		Soft_I2C_Stop();
	CALL       _Soft_I2C_Stop+0
;MCP2003_Example.c,81 :: 		num = num + 1;
	INCF       _num+0, 1
;MCP2003_Example.c,82 :: 		if(num == 10) num=0;
	MOVF       _num+0, 0
	XORLW      10
	BTFSS      STATUS+0, 2
	GOTO       L_main19
	CLRF       _num+0
L_main19:
;MCP2003_Example.c,83 :: 		} while (1);
	GOTO       L_main13
;MCP2003_Example.c,84 :: 		}
	GOTO       $+0
; end of _main
